//-----------------------------------------
// LScript Modeler Lattice Split Polygon
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=1.1;
//v1.1
//Fixed crash bug
//V1
//Added vmap support

@version 2.2
@warnings
@script modeler

// global values go here
c0,c1,c2;
ison=0;
//myvmap,myshort,mylong;

main
{
    mylong=recall("MGLatticeSplitPolygonLong",2);
    myshort=recall("MGLatticeSplitPolygonShort",2);
    myvmap=recall("MGLatticeSplitPolygonVmap",1);
    // requester code goes here

    reqbegin("MG Lattice Split Polygon Ver:"+myversion);

    c0 = ctlminislider("Long Side",mylong,1,50);
    c1 = ctlminislider("Short Side",myshort,1,50);
    c2 = ctlcheckbox("Interpolate Vmaps",myvmap);

     make(0);
     ctlrefresh(c0,"make");
     ctlrefresh(c1,"make");
     ctlrefresh(c2,"make");

    if (!reqpost())
    {
        if(ison)
        {   
            undo();
            undo();
            undo();
            undo();
            undo();
        }
        return;
    }

//    lattice(mylong,myshort,myvmap);

    // get requester control values here

    reqend();


    // processing code goes here

}

make:value
{
    mylong=getvalue(c0);
    myshort=getvalue(c1);
    myvmap=getvalue(c2);

    if (mylong<1)
    {
        mylong=1;
        setvalue(c0,mylong);
        return;
    }
    if (myshort<1)
    {
        myshort=1;
        setvalue(c1,myshort);
        return;
    }


    if(ison)
    {
        undo();
        undo();
        undo();
        undo();
        undo();
    }

//    myvmap=0;

    lattice(mylong,myshort,myvmap);
    ison=1;

    store("MGLatticeSplitPolygonLong",mylong);
    store("MGLatticeSplitPolygonShort",myshort);
    store("MGLatticeSplitPolygonVmap",myvmap);

}





lattice:plong,pshort,pvmap
{
    selmode(USER);
    editbegin();

        oldpolys=polygons;
        index=1;
        pindex=1;
        foreach(p,polygons)
        {
            if(!p.isCurve()&&p.pointCount==4)
            {
                longside=1;
                mylength=vmag(pointinfo(p.points[2])-pointinfo(p.points[1]));
                loop=@1,2,3,4,1,2,3,4@;
                for(i=2;i<=4;i++)
                {
                    mytemp=vmag(pointinfo(p.points[loop[i+1]])-pointinfo(p.points[i]));
                    if(mytemp>mylength)
                    {
                        longside=i;
                        mylength=mytemp;
                    }
                }
                //find long side
                //put corner points in array
                mysurf=p.surface;
                corners[1]=p.points[loop[longside]];
                corners[2]=p.points[loop[longside+1]];
                corners[3]=p.points[loop[longside+2]];
                corners[4]=p.points[loop[longside+3]];
                
                pinfo[index][1]=p;
                pinfo[index][2]=corners;

                
                cornerpos[1]=pointinfo(corners[1]);
                cornerpos[2]=pointinfo(corners[2]);
                cornerpos[3]=pointinfo(corners[3]);
                cornerpos[4]=pointinfo(corners[4]);


                //make other points
                longint=1/plong;
                shortint=1/pshort;
//debug();
                for(i=0;i<=plong;i++)
                {
                    for(j=0;j<=pshort;j++)
                    {
                        scalefactor[1]=(1-i*longint)*(1-j*shortint);
                        scalefactor[2]=(i*longint)*(1-j*shortint);
                        scalefactor[3]=(i*longint)*(j*shortint);
                        scalefactor[4]=(1-i*longint)*(j*shortint);
                        

                        pointpos=cornerpos[1]*scalefactor[1]
                                +cornerpos[2]*scalefactor[2]
                                +cornerpos[3]*scalefactor[3]
                                +cornerpos[4]*scalefactor[4];
                        mypoint=addpoint(pointpos);
                        mypoints[i+1][j+1]=mypoint;

                        pinfo[index][3][i+1][j+1]=mypoint;


                    }
                }
//                debug();
                //make all polygons
                for(i=1;i<=plong;i++)
                {
                    for(j=1;j<=pshort;j++)
                    {
                        newcorners=@mypoints[i][j],mypoints[i+1][j],mypoints[i+1][j+1],mypoints[i][j+1]@;
                        mypolys[pindex]=addpolygon(newcorners,mysurf);
                        pindex++;
                    }
                }
                delpolys[index]=p;
                index++;
            }
        }
    editend();
    
    editbegin();


        if(pvmap)
        {
//debug();
            vmindex=1;
            mymap=VMap();
            while(mymap)
            {
                for(p=1;p<=pinfo.size();p++)
                {
                    allnil=1;
                    cornerval[1]=0;
                    for(i=1;i<=4;i++)
                    {
//if(mymap.name=="Texture") debug();
//debug();
                        mytype=mymap.type;
                        if(mymap.isMapped(pinfo[p][2][i],pinfo[p][1]))
                            cornerval[i]=mymap.getValue(pinfo[p][2][i],pinfo[p][1]);
                        else
                            cornerval[i]=mymap.getValue(pinfo[p][2][i]);

                        if(cornerval[i]!=nil)
                            allnil=0;
                        else
                        {
                            for(k=1;k<=mymap.dimensions;k++)
                            {
                                cornerval[i][k]=0;
                            }
                        }
                    }
                    if(!allnil)
                    {
                        allpoints=pinfo[p][3];
                        for(i=1;i<=allpoints.size();i++)
                        {
                            for(j=1;j<=allpoints[i].size();j++)
                            {
                                x=i - 1;
                                y=j - 1;
                                scalefactor[1]=(1-x*longint)*(1-y*shortint);
                                scalefactor[2]=(x*longint)*(1-y*shortint);
                                scalefactor[3]=(x*longint)*(y*shortint);
                                scalefactor[4]=(1-x*longint)*(y*shortint);
                                pointval[1]=cornerval[1];
                                for(k=1;k<=mymap.dimensions;k++)
                                {
                                    pointval[k]=cornerval[1][k]*scalefactor[1]
                                                +cornerval[2][k]*scalefactor[2]
                                                +cornerval[3][k]*scalefactor[3]
                                                +cornerval[4][k]*scalefactor[4];
                                }
                                    mymap.setValue(allpoints[i][j],pointval);
                            }
                        }
                    }
                }
                mymap=mymap.next();
            }
        }

    editend();

    selmode(USER);
    selpolygon(CLEAR);
    selpolygon(SET,POLYID,delpolys);
    delete();
    selpolygon(SET,POLYID,mypolys);
}